import sys
from socket import *
from time import sleep
import struct
from visual import *
import numpy

# args
if len(sys.argv) == 2:
	remoteHost = sys.argv[1]
else:
	print "Usage: %s <WAM IP address>" % sys.argv[0]
	exit()

# set up socket
PORT_SRC = 5556
PORT_DEST = 5557
MSG_FORMAT = "ddd"  # messages contain 3 doubles
MSG_FORMAT_SEND = "dddd"  # messages contain 4 doubles
MSG_SIZE_SEND = struct.calcsize(MSG_FORMAT_SEND)
MSG_SIZE = struct.calcsize(MSG_FORMAT)

sock = socket(AF_INET, SOCK_DGRAM)
#sock.setblocking(0)
sock.bind(('', PORT_SRC))
sock.connect((remoteHost,PORT_DEST))


# set up visual
scene.fullscreen = True
#scene.cursor.visible = False
#scene.autocenter = True
#scene.autoscale = True
scene.center = (0,-0.4,1)
scene.scale = (2.5,2.5,2.5)

f = frame()
f.rotate(angle = -pi/2.0, axis = (1,0,0), origin = (0,0,0))
f.rotate(angle = -pi/2.0, axis = (0,1,0), origin = (0,0,0))
f.rotate(angle = pi*0.2, axis = (1,0,0), origin = (0,0,0))

# unit vectors
#arrow(pos = (0,0,0), axis = (1,0,0), color = color.red, frame = f)
#arrow(pos = (0,0,0), axis = (0,1,0), color = color.green, frame = f)
#arrow(pos = (0,0,0), axis = (0,0,1), color = color.blue, frame = f)

# floor
xMin,xMax = -1.0,0.4
yMin,yMax = -0.8,0.8
z = -0.5
step = 0.1

for x in numpy.linspace(xMin, xMax, (xMax-xMin)/step):
	curve(pos = [(x,yMin,z), (x,yMax,z)], frame = f)
for y in numpy.linspace(yMin, yMax, (yMax-yMin)/step):
	curve(pos = [(xMin,y,z), (xMax,y,z)], frame = f)

# haptic objects
sphere(pos = (0.4,-0.15,0), radius = 0.11, color = color.green, opacity = 0.6, frame = f)
box(pos = (0.35,0.2,0), length = 0.19, height = 0.19, width = 0.19, color = color.blue, opacity = 0.6, frame = f)

# end point
ep = sphere(pos = (0,0,0), radius = 0.01, color = color.red, frame = f)


# loop!
gcomp = 100;
while True:
	if scene.kb.keys:  # If any input was pressed
	        s = scene.kb.getkey()
		if s == 'up':
			gcomp = 1
		elif s == 'down':
			gcomp = 2
		elif s == 'r':
			gcomp = 0
	        sock.send(struct.pack(MSG_FORMAT_SEND,gcomp,1,1,1))
	        sock.send(struct.pack(MSG_FORMAT_SEND,100,1,1,1))
	ep.pos = struct.unpack(MSG_FORMAT, sock.recv(MSG_SIZE))
sock.close()

