import sys
from socket import *
import time
import struct
from visual import *
import numpy
import subprocess
import os

# args
if len(sys.argv) == 2:
  remoteHost = sys.argv[1]
else:
#  remoteHost = "192.168.139.236"
 print "Usage: %s <WAM IP address>" % sys.argv[0]
 exit()


# set up socket
PORT_SRC1 = 5556
PORT_SRC2 = 5558
PORT_DEST1 = 5555
PORT_DEST2 = 5557
MSG_FORMAT = "ddd"  # messages contain 3 doubles
SEND_MSG_FORMAT = "?" #Windows sends 60 bytes while ubuntu sends 56 bytes
char_MSG = 'c'
MSG_SIZE = struct.calcsize(MSG_FORMAT)
sock1 = socket(AF_INET, SOCK_DGRAM)
#sock1.setblocking(0)
sock1.bind(('', PORT_SRC1))
sock1.connect((remoteHost,PORT_DEST1))
sock2 = socket(AF_INET, SOCK_DGRAM)
#sock2.setblocking(0)
sock2.bind(('', PORT_SRC2))
sock2.connect((remoteHost,PORT_DEST2))

# set up visual
scene.fullscreen = True
#scene.cursor.visible = False
#scene.autocenter = True
#scene.autoscale = True
scene.center = (0,-0.4,1)
scene.scale = (2.5,2.5,2.5)


f = frame()
f.rotate(angle = -pi/2.0, axis = (1,0,0), origin = (0,0,0))
f.rotate(angle = -pi/2.0, axis = (0,1,0), origin = (0,0,0))
f.rotate(angle = pi*0.2, axis = (1,0,0), origin = (0,0,0))

# unit vectors
#arrow(pos = (0,0,0), axis = (1,0,0), color = color.red, frame = f)
#arrow(pos = (0,0,0), axis = (0,1,0), color = color.green, frame = f)
#arrow(pos = (0,0,0), axis = (0,0,1), color = color.blue, frame = f)

# floor
xMin,xMax = -1.0,0.4
yMin,yMax = -0.8,0.8
z = -0.5
step = 0.1

for x in numpy.linspace(xMin, xMax, (xMax-xMin)/step):
  curve(pos = [(x,yMin,z), (x,yMax,z)], frame = f)
for y in numpy.linspace(yMin, yMax, (yMax-yMin)/step):
  curve(pos = [(xMin,y,z), (xMax,y,z)], frame = f)

# haptic objects
sphere(pos = (0.4,-0.15,0), radius = 0.11, color = color.green, opacity = 0.6, frame = f)
box(pos = (0.35,0.2,0), length = 0.19, height = 0.19, width = 0.19, color = color.blue, opacity = 0.6, frame = f)

# end point
ep1 = sphere(pos = (0,0,0), radius = 0.01, color = color.red, frame = f)
ep2 = sphere(pos = (0,0,0), radius = 0.01, color = color.red, frame = f)


# loop!
while True:
  data1 = struct.pack(SEND_MSG_FORMAT,0)
  data2 = struct.pack(SEND_MSG_FORMAT,0)
  sock1.send(data1)
  sock2.send(data2)
  #rate(550)
  if scene.kb.keys:
    s=scene.kb.getkey();
    if s==' ': #'shift+delete':
      data1 = struct.pack(SEND_MSG_FORMAT,1)
      sock1.send(data1)
      sock1.close()
      data2 = struct.pack(SEND_MSG_FORMAT,1)
      sock2.send(data2)
      sock2.close()
      time.sleep(4)
      subprocess.Popen(["python", "haptic_world_visualization.py", remoteHost])
      os._exit(0)
  data1 = sock1.recv(MSG_SIZE)
  data2 = sock2.recv(MSG_SIZE)
  while(len(data1) != MSG_SIZE):
    data1 = sock1.recv(MSG_SIZE)
  while(len(data2) != MSG_SIZE):
    data2 = sock2.recv(MSG_SIZE)
  ep1.pos = struct.unpack(MSG_FORMAT, data1)
  ep2.pos = struct.unpack(MSG_FORMAT, data2)

sock1.close()
sock2.close()
