/*
 * bypass_safety_module.h
 *
 *  Created on: Mar 30, 2012
 *      Author: dc
 */

#ifndef BYPASS_SAFETY_MODULE_H_
#define BYPASS_SAFETY_MODULE_H_

#include <barrett/products/puck.h>
#include <barrett/products/safety_module.h>


/************************** IMPORTANT SAFETY NOTICE ****************************
 * The function below enables remote activation of Barrett's WAM Arm. It is
 * designed to support the needs of mobile, hazardous, and autonomous
 * applications where human operators do not have physical access to the robot.
 * It allows the robot to be turned on and activated from software.
 *
 * IT'S DANEROUS TO USE THE WAM IN THIS MANNER IF HUMANS WILL BE IN ITS WORKSPACE.
 *
 * This code allows the robot to become active without any direct human
 * intervention. This behavior violates recommendations from the Robotics
 * Industries Association. Please think carefully before using this code in your
 * application. Contact support@barrett.com with any questions.
 *
 * This functionality requires SafetyModule firmware version >= 197.
 ************************** IMPORTANT SAFETY NOTICE ***************************/

inline void bypassSafetyModule(const barrett::SafetyModule* sm) {
  using barrett::Puck;

    Puck& sp = *sm->getPuck();
    sp.setProperty(Puck::LOCK, 1234, true);
    sp.setProperty(Puck::LOCK, 18384, true);
    sp.setProperty(Puck::LOCK, 23, true);
    sp.setProperty(Puck::LOCK, 3145, true);
    sp.setProperty(Puck::LOCK, 1024, true);
    sp.setProperty(Puck::LOCK, 1, true);
}

#endif /* BYPASS_SAFETY_MODULE_H_ */
